<template>
  <ul class="tab__list">
    <li
      v-for="(tab, index) in tabs"
      :key="tab.props.title"
      @click="selectTab(index)"
      class="tab__item"
      :class="{ selected: index == active }"
    >
      {{ tab.props.title }}
    </li>
  </ul>
  <slot></slot>
</template>
<script>
import { provide, computed, ref } from 'vue'
export default {
  name: 'Tabs',
  props: {
    modelValue: {
      type: [String, Number]
    }
  },
  emits: ['update:modelValue'],
  setup(props, { emit }) {
    const active = computed(() => props.modelValue)
    const tabs = ref([])
    const hideTabIndex = ref(null)

    const selectTab = tab => {
      if (tab === active.value) return

      hideTabIndex.value = active.value
      emit('update:modelValue', tab)
      setTimeout(() => (hideTabIndex.value = null), 700)

      // setTimeout(() => {
      //   emit('update:modelValue', tab)
      //   hideTabIndex.value = null
      // }, 700)
    }

    provide('tabsState', {
      active,
      hideTabIndex,
      tabs
    })

    return {
      tabs,
      active,
      selectTab
    }
  }
}
</script>
